Bug 1418370 - Review Request: golang-github-karlseguin-expect - A testing framework for Go
Summary: Review Request: golang-github-karlseguin-expect - A testing framework for Go
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Dusty Mabe
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1415341
TreeView+ depends on / blocked
 
Reported: 2017-02-01 16:32 UTC by Jan Chaloupka
Modified: 2017-06-15 09:20 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-06-15 02:59:07 UTC
Type: ---
dustymabe: fedora-review+


Attachments (Terms of Use)

Description Jan Chaloupka 2017-02-01 16:32:16 UTC
Spec URL: https://jchaloup.fedorapeople.org/reviews/golang-github-karlseguin-expect/golang-github-karlseguin-expect.spec

SRPM URL: https://jchaloup.fedorapeople.org/reviews/golang-github-karlseguin-expect/golang-github-karlseguin-expect-0-0.1.git5c2eadb.fc24.src.rpm

Description: A testing framework for Go

Fedora Account System Username: jchaloup

$ rpmlint golang-github-karlseguin-expect-0-0.1.git5c2eadb.fc24.src.rpm golang-github-karlseguin-expect-devel-0-0.1.git5c2eadb.fc24.noarch.rpm golang-github-karlseguin-expect-unit-test-devel-0-0.1.git5c2eadb.fc24.x86_64.rpm
3 packages and 0 specfiles checked; 0 errors, 0 warnings.

Comment 1 Dusty Mabe 2017-03-12 17:16:12 UTC
am I correct that we are only creating a "devel" package here for use in building other golang apps?

Comment 2 Dusty Mabe 2017-03-12 20:39:10 UTC


Issues:
=======
- Package installs properly.
  Note: Installation errors (see attachment)
  See: https://fedoraproject.org/wiki/Packaging:Guidelines

This is because golang(github.com/wsxiaoys/terminal/color) is not yet
in the repos: see https://bugzilla.redhat.com/show_bug.cgi?id=1418368


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "MIT/X11 (BSD like)", "Unknown or generated". 14 files have
     unknown license. Detailed output of licensecheck in
     /home/vagrant/1418370-golang-github-karlseguin-expect/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.

[ ]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/share/gocode/src,
     /usr/share/gocode, /usr/share/gocode/src/github.com

These are owned by the golang package, should this package require 
golang to be installed?


[-]: %build honors applicable compiler flags or justifies otherwise.

This package does not build anything

[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 40960 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in golang-
     github-karlseguin-expect-devel , golang-github-karlseguin-expect-unit-
     test-devel
[x]: Package functions as described.

I was able to take two files from upstream [1] [2] and test that it works.

	[vagrant@f25vanilla ~]$ go test 
	ok      _/home/vagrant  0.004s

	# then edited the file to make a test fail:

	[vagrant@f25vanilla ~]$ go test 

	build.RequestTests
	 ×  SetsProtocol                                                          0ms 
	    request_test.go:23                      expected 4 to be equal to 5

	Failure summary
	 × build.RequestTests.SetsProtocol                             1

	exit status 1
	FAIL    _/home/vagrant  0.004s


[1] https://github.com/karlseguin/expect/blob/master/build/request_test.go
[2] https://github.com/karlseguin/expect/blob/master/build/request.go



[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Rpmlint is run on all installed packages.
     Note: Mock build failed
     See: http://fedoraproject.org/wiki/Packaging/Guidelines#rpmlint

This is because golang(github.com/wsxiaoys/terminal/color) is not yet
in the repos: see https://bugzilla.redhat.com/show_bug.cgi?id=1418368

[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Installation errors
-------------------
INFO: mock.py version 1.3.4 starting (python version = 3.5.2)...
Start: init plugins
INFO: selinux enabled
Finish: init plugins
Start: run
Start: chroot init
INFO: calling preinit hooks
INFO: enabled root cache
INFO: enabled dnf cache
Start: cleaning dnf metadata
Finish: cleaning dnf metadata
INFO: enabled HW Info plugin
Mock Version: 1.3.4
INFO: Mock Version: 1.3.4
Finish: chroot init
INFO: installing package(s): /home/vagrant/1418370-golang-github-karlseguin-expect/results/golang-github-karlseguin-expect-unit-test-devel-0-0.1.git5c2eadb.fc25.x86_64.rpm /home/vagrant/1418370-golang-github-karlseguin-expect/results/golang-github-karlseguin-expect-devel-0-0.1.git5c2eadb.fc25.noarch.rpm
ERROR: Command failed. See logs for output.
 # /usr/bin/dnf --installroot /var/lib/mock/fedora-25-x86_64/root/ --releasever 25 --disableplugin=local --setopt=deltarpm=false install /home/vagrant/1418370-golang-github-karlseguin-expect/results/golang-github-karlseguin-expect-unit-test-devel-0-0.1.git5c2eadb.fc25.x86_64.rpm /home/vagrant/1418370-golang-github-karlseguin-expect/results/golang-github-karlseguin-expect-devel-0-0.1.git5c2eadb.fc25.noarch.rpm --setopt=tsflags=nocontexts


Rpmlint
-------
Checking: golang-github-karlseguin-expect-devel-0-0.1.git5c2eadb.fc25.noarch.rpm
          golang-github-karlseguin-expect-unit-test-devel-0-0.1.git5c2eadb.fc25.x86_64.rpm
          golang-github-karlseguin-expect-0-0.1.git5c2eadb.fc25.src.rpm
3 packages and 0 specfiles checked; 0 errors, 0 warnings.




Requires
--------
golang-github-karlseguin-expect-unit-test-devel (rpmlib, GLIBC filtered):
    golang-github-karlseguin-expect-devel

golang-github-karlseguin-expect-devel (rpmlib, GLIBC filtered):
    golang(github.com/wsxiaoys/terminal/color)



Provides
--------
golang-github-karlseguin-expect-unit-test-devel:
    golang-github-karlseguin-expect-unit-test-devel
    golang-github-karlseguin-expect-unit-test-devel(x86-64)

golang-github-karlseguin-expect-devel:
    golang(github.com/karlseguin/expect)
    golang(github.com/karlseguin/expect/build)
    golang(github.com/karlseguin/expect/mock)
    golang-github-karlseguin-expect-devel



Source checksums
----------------
https://github.com/karlseguin/expect/archive/5c2eadb35b136ae1529cef7fc966188c6267323e/expect-5c2eadb.tar.gz :
  CHECKSUM(SHA256) this package     : ddf0ca94dfea66ad7f53a6c24b983f7612d80c0044ad2f1ff513393fb4e9bb2a
  CHECKSUM(SHA256) upstream package : ddf0ca94dfea66ad7f53a6c24b983f7612d80c0044ad2f1ff513393fb4e9bb2a


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -b 1418370
Buildroot used: fedora-25-x86_64
Active plugins: Generic, Shell-api
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 3 Jan Chaloupka 2017-03-13 12:57:51 UTC
> [ ]: Package must own all directories that it creates.
>     Note: Directories without known owners: /usr/share/gocode/src,
>     /usr/share/gocode, /usr/share/gocode/src/github.com
>
>These are owned by the golang package, should this package require 
>golang to be installed?

Does not make much sense to install devel source code without the compiler so the dependency on golang is intentionally ignored

Comment 4 Dusty Mabe 2017-03-13 13:29:29 UTC
(In reply to Jan Chaloupka from comment #3)
> > [ ]: Package must own all directories that it creates.
> >     Note: Directories without known owners: /usr/share/gocode/src,
> >     /usr/share/gocode, /usr/share/gocode/src/github.com
> >
> >These are owned by the golang package, should this package require 
> >golang to be installed?
> 
> Does not make much sense to install devel source code without the compiler
> so the dependency on golang is intentionally ignored

ok

[X]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/share/gocode/src,
     /usr/share/gocode, /usr/share/gocode/src/github.com

LGTM

Comment 5 Gwyn Ciesla 2017-03-13 13:31:36 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/golang-github-karlseguin-expect

Comment 6 Fedora Update System 2017-03-13 18:01:30 UTC
golang-github-karlseguin-expect-0-0.1.git5c2eadb.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2017-5bcf8741ee

Comment 7 Fedora Update System 2017-03-13 18:01:48 UTC
golang-github-karlseguin-expect-0-0.1.git5c2eadb.el6 has been submitted as an update to Fedora EPEL 6. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2017-8d11dae8d3

Comment 8 Fedora Update System 2017-03-13 18:02:10 UTC
golang-github-karlseguin-expect-0-0.1.git5c2eadb.fc26 has been submitted as an update to Fedora 26. https://bodhi.fedoraproject.org/updates/FEDORA-2017-93657fb597

Comment 9 Fedora Update System 2017-03-13 18:02:33 UTC
golang-github-karlseguin-expect-0-0.1.git5c2eadb.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2017-0898aa73c1

Comment 10 Fedora Update System 2017-03-13 18:02:53 UTC
golang-github-karlseguin-expect-0-0.1.git5c2eadb.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2017-f6713bbc4b

Comment 11 Fedora Update System 2017-03-14 00:17:12 UTC
golang-github-karlseguin-expect-0-0.1.git5c2eadb.el6 has been pushed to the Fedora EPEL 6 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2017-8d11dae8d3

Comment 12 Fedora Update System 2017-03-14 00:19:45 UTC
golang-github-karlseguin-expect-0-0.1.git5c2eadb.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2017-0898aa73c1

Comment 13 Fedora Update System 2017-03-14 01:20:16 UTC
golang-github-karlseguin-expect-0-0.1.git5c2eadb.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-f6713bbc4b

Comment 14 Fedora Update System 2017-03-14 01:23:59 UTC
golang-github-karlseguin-expect-0-0.1.git5c2eadb.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-5bcf8741ee

Comment 15 Fedora Update System 2017-03-14 03:22:15 UTC
golang-github-karlseguin-expect-0-0.1.git5c2eadb.fc26 has been pushed to the Fedora 26 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-93657fb597

Comment 16 Dusty Mabe 2017-03-30 00:29:49 UTC
should be able to push to stable now

Comment 17 Fedora Update System 2017-06-15 02:59:07 UTC
golang-github-karlseguin-expect-0-0.1.git5c2eadb.fc26 has been pushed to the Fedora 26 stable repository. If problems still persist, please make note of it in this bug report.

Comment 18 Fedora Update System 2017-06-15 04:48:35 UTC
golang-github-karlseguin-expect-0-0.1.git5c2eadb.el6 has been pushed to the Fedora EPEL 6 stable repository. If problems still persist, please make note of it in this bug report.

Comment 19 Fedora Update System 2017-06-15 08:19:42 UTC
golang-github-karlseguin-expect-0-0.1.git5c2eadb.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.

Comment 20 Fedora Update System 2017-06-15 09:20:50 UTC
golang-github-karlseguin-expect-0-0.1.git5c2eadb.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.